package org.rcisoft.bus.ossinfo.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.rcisoft.bus.ossinfo.dao.OssInfoRepository;
import org.rcisoft.bus.ossinfo.entity.OssInfo;
import org.rcisoft.bus.ossinfo.service.OssinfoService;
import org.rcisoft.core.model.CyPageInfo;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.util.CyUserUtil;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
@Service
@Transactional(readOnly = true,propagation = Propagation.NOT_SUPPORTED)
@Slf4j
public class OssinfoServiceImpl extends ServiceImpl<OssInfoRepository, OssInfo>implements OssinfoService {

    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public CyPersistModel persist(OssInfo ossInfo) {
        int line = baseMapper.insert(ossInfo);
        log.debug(CyUserUtil.getAuthenUsername()+"新增了ID为"+
                ossInfo.getBusinessId()+"的信息");
        return new CyPersistModel(line);
    }
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public CyPersistModel remove(OssInfo ossInfo) {
        ossInfo.setDeleted();
        int line = baseMapper.deleteById(ossInfo);
        log.debug(CyUserUtil.getAuthenUsername()+"删除了ID为"+
                ossInfo.getBusinessId()+"的信息");
        return new CyPersistModel(line);
    }
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public CyPersistModel merge(OssInfo ossInfo) {
        int line = baseMapper.deleteById(ossInfo);
        log.debug(CyUserUtil.getAuthenUsername()+"修改了ID为"+
                ossInfo.getBusinessId()+"的信息");
        return new CyPersistModel(line);
    }

    @Override
    public OssInfo findById(int id) {
        return baseMapper.selectById(id);
    }

    @Override
    public IPage<OssInfo> findAllByPagination(CyPageInfo<OssInfo> paginationUtility, OssInfo ossInfo) {
        return baseMapper.queryOssInfosPaged(paginationUtility ,ossInfo);
    }

    @Override
    public List<OssInfo> findAll(OssInfo ossInfo) {
        return baseMapper.queryOssInfos(ossInfo);
    }

    @Override
    public List<OssInfo> export(OssInfo ossInfo) {
        List<OssInfo> ossInfoList =baseMapper.queryOssInfos(ossInfo);
        return ossInfoList;
    }
}
